#### connect (9 of 12 overloads)

(Deprecated: Use range overload.) Establishes a socket connection by trying each endpoint in a sequence.

    template<
        typename Protocol,
        typename Executor,
        typename Iterator,
        typename ConnectCondition>
    Iterator connect(
        basic_socket< Protocol, Executor > & s,
        Iterator begin,
        ConnectCondition connect_condition,
        constraint_t<!is_endpoint_sequence< Iterator >::value >  = 0);

This function attempts to connect a socket to one of a sequence of endpoints. It does this by repeated calls to the socket's `connect` member function, once for each endpoint in the sequence, until a connection is successfully established.

###### Parameters

s

  The socket to be connected. If the socket is already open, it will be closed.

begin

  An iterator pointing to the start of a sequence of endpoints.

connect_condition

  A function object that is called prior to each connection attempt. The signature of the function object must be:

      bool connect_condition(
         const asio::error_code& ec,
         const typename Protocol::endpoint& next);

  The `ec` parameter contains the result from the most recent connect operation. Before the first connection attempt, `ec` is always set to indicate success. The `next` parameter is the next endpoint to be tried. The function object should return true if the next endpoint should be tried, and false if it should be skipped.

###### Return Value

On success, an iterator denoting the successfully connected endpoint. Otherwise, the end iterator.

###### Exceptions

asio::system_error

  Thrown on failure. If the sequence is empty, the associated `error_code` is `asio::error::not_found`. Otherwise, contains the error from the last connection attempt.

###### Remarks

This overload assumes that a default constructed object of type `Iterator` represents the end of the sequence. This is a valid assumption for iterator types such as `asio::ip::tcp::resolver::iterator`.